spec:
  inputs:
    'package_dir':
      default: 'packages'
    'build_image_tag':
      default: '0.5.2'
    'docker_tag':
      default: '27.1.1'
---

include:
  - component: gitlab.com/alexlab-cloud/infra/ci/lib/common/bootstrap.gitlab-ci@main

'job:publish-devcontainer-images':
  services:
    - name: docker:$[[ inputs.docker_tag ]]-dind
      alias: docker
  extends:
    - '.base-stage:publish'
  variables:
    DOCKER_HOST: tcp://docker:2376
    DOCKER_TLS_VERIFY: '1'
    DOCKER_TLS_CERTDIR: '/certs'
    DOCKER_CERT_PATH: '/certs/client'
    DOCKER_DRIVER: overlay2
  script:
    # Iterate over every folder and subfolder in packages/ that contains a package.json file
    - >
      for PKG_PATH in $(find $[[ inputs.package_dir ]]/** -type d -exec test -f {}/package.json \; -printf '%f\n'); do
        PKG_NAME=$(basename $PKG_PATH)
        TAG=$(jq -r '.version' $PKG_PATH/package.json)
        
        docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
        pnpm devcontainer build --image-name $CI_REGISTRY/$CI_PROJECT_PATH/$PKG_NAME:$TAG --platform linux --workspace-folder $PKG_PATH
        docker push $CI_REGISTRY/$CI_PROJECT_PATH/$PKG_NAME:$TAG
      done
    